import matplotlib.pylab as plt
L = 100
# d = 2 # Fixed
initial_trees = 0.80
p = 0.01
f = 0.001

try:
    raw_input
except:
    raw_input = input

import random


tree, burning, space = 'TB.'
hood = ((-1,-1), (-1,0), (-1,1),
        (0,-1),          (0, 1),
        (1,-1),  (1,0),  (1,1))

def initialise():
    grid = {(x,y): (tree if random.random()<= initial_trees else space)
            for x in range(L)
            for y in range(L) }
    return grid

def gprint(grid):
    txt = '\n'.join(''.join(grid[(x,y)] for x in range(L))
                    for y in range(L))
    print(txt)

def quickprint(grid):
    t = b = 0
    for x in range(L):
        for y in range(L):
            if grid[(x,y)] in (tree, burning):
                t += 1
                if grid[(x,y)] == burning:
                    b += 1
    return b
def counter(grid):
    t = 0
    for x in range(L):
        for y in range(L):
            if grid[x ,y] in (tree, burning):
                t += 1
    return t

def gnew(grid):
    newgrid = {}
    for x in range(L):
        for y in range(L):
            if grid[(x,y)] == burning:
                newgrid[(x,y)] = space
            elif grid[(x,y)] == space:
                newgrid[(x,y)] = tree if random.random()<= p else space
            elif grid[(x,y)] == tree:
                newgrid[(x,y)] = (burning
                                   if any(grid.get((x+dx,y+dy),space) == burning
                                            for dx,dy in hood)
                                        or random.random()<= f
                                   else tree)
    return newgrid

if __name__ == '__main__':
    grid = initialise()
    iter = 0
    burn = []
    trees = []
    y = []
    while iter < 100:
        burn.append(quickprint(grid))
        trees.append(counter(grid))
        grid = gnew(grid)
        y.append(iter)
        iter +=1
    fig = plt.figure(facecolor='w')
    ax = fig.add_subplot(111)
    ax.plot(y, burn, 'r', alpha=0.5, lw=2, label='burnt')
    ax.plot(y, trees, 'g', alpha=0.5, lw=2, label='trees')
    ax.legend()
    plt.show()
